; DATE::	27/10/11    23:25


[BITS 16]
;	Le secteur d'amorcage (MBR pour le disques dur) est charg en mmoire par le BIOS  
;	 l'adresse 0x7C00. Alors, il faut indiquer  NASM d'ajouter un nombre (celui crit juste aprs la directive) 
;	 toutes les adresses qu'on utilise dans le code
[ORG 0x7C00]

; Voici les formidables sites qui mon aid a construire ce code :)  http://mysterie.fr/prog/code/asm/bootwrit_fr.html
														;			http://viralpatel.net/taj/tutorial/hello_world_bootloader.php
														;			http://perso.numericable.fr/fvirtman/recueil/
														;			http://www.alrj.org/docs/hardware/graph-asm.php
														;			http://paiiou.free.fr/Programmation/Assembleur/afficher.php
														;			http://a-os.teria.org/sam86/asmmm.htm
														;			http://netsquale.chez.com/asmgraf1.htm
														; 			http://www.osdever.net/tutorials/view/descriptor-tables-gdt-idt-ldt
														;			http://www.internals.com/articles/protmode/protmode.htm
														; 			http://www.brokenthorn.com/Resources/OSDevVga.html

jmp 	main
;================================================================================================
;DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA
;================================================================================================
	;------------------------------------Ce qui suit sert  accder  la cl USB depuis windows aprs modification du Bootsector avec HxD.exe, sinon windows ne reconnatra plus la cl USB.
		; bootdb  db     'COS2000A'                ;Fabricant + nsrie Formatage
		; sizec   dw      512                      ;octet/secteur
				; db      1                        ;secteur/cluster
		; reserv  dw      1                        ;secteur reserv
		; nbfat   db      2                        ;nb de copie de la FAT
		; nbfit   dw      224                      ;taille rep racine
		; allclu  dw      2880                     ;nb secteur du volume si < 32 mg
				; db      0F0h                     ;Descripteur de mdia
		; fatsize dw      9                        ;secteur/FAT
		; nbtrack dw      18                       ;secteur/piste       
		; head    dw      2                        ;nb de tteb de lecture/criture
		; hidden  dd      0                        ;nombre de secteur cachs
				; dd      0                        ;si nbsecteur = 0 nbsect                                       ; the number of sectors
		; bootdrv db      0                        ;Lecteur de dmarrage
		; bootsig db      0                        ;NA
				; db      29h                      ;boot signature 29h
		; bootsig2 dd     01020304h                ;no de serie
		; pope    db      'COS2000    '            ;nom de volume
				; db      'FAT12   '               ;FAT
	;---------------------------------------
	%define		BASE   		0x100	; 0x0100:0x0 = 0x1000
	%define 	nbr_sector  0x20  		; nombre de secteurs de 512 octets a charger
	
	VRAM	dw	0xA000  ; [V]ideo[RAM] idem, mais cette fois-ci en mode graphique (pixel) .

	msg 		db			0xD		; 0x27 --> '	 |	 0xD --> ASCII: retour chariot
				db 		    '  )\._.,--....,',0x27,',``.',0xD
				db		    ' /,   _.. \   _\  ;`._ ,.',0xD
				db			'`._.-(,_..',0x27,'--(,_..',0x27,'`-.;.',0x27,0xD,0xD
				db			'LOADING BOOTLOADER...................OK',0xD,'Hello World! :)',0xD,'Appuyer sur une touche pour charger le kernel'			
	end_msg:
	
	TRAM		dw	0xB800		; [T]ext[RAM] adresse du dbut de la zone mappe qui est la mmoire vido, mais en mode texte et non graphique (pixel) .
	
	bootdev		db 		0

	param_my_write		dd		0	; char* tampon
						dd		0	; dword limite
;================================================================================================
;END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA
;================================================================================================

;================================================================================================
;FONCTIONS	FONCTIONS	FONCTIONS	FONCTIONS	FONCTIONS	FONCTIONS	FONCTIONS	FONCTIONS
;================================================================================================
	%macro  iowait 0 

		mov		cl, 4
        rep		out 0x80,al
		
	%endmacro
	;=============
	; my_write
	; Affiche une chaine de caractere  l'cran
	; Entre : param_my_write = adresse se la chaine  afficher sur 4 octet
	;		 param_my_write+4 = pointeur de fin de chaine
	; Sotie: Ecran
	;=============

	my_write:	; int my_write (char* tampon, dword limite, char* color );
	
				; ECX --> pointeur sur le tampon de la chaine de caractere  afficher
				; [param_my_write + 4] --> limite d'octet  transferer
				; SI --> n de lignes  l'cran ( 1 ligne = 80 words ) ( pour info cela dpend de la taille de votre screen, j'utilise un 10'1 pouces pour les tests )	
					xor		di, di			; Affiche du dbut de l'cran
					xor		si, si			; n de la ligne
					mov		ah, 00001111b
				;
				; La mmoire video est mappe en mmoire  l'adresse physique 0xB8000
					mov 	es, [TRAM]
				;
				; Rcupration des parametres 
					mov 	ecx, [param_my_write]		; char * tampon
				;	
		;		+==============================================================================+
		;		|		BOUCLE		BOUCLE		BOUCLE		BOUCLE		BOUCLE		BOUCLE	   |
		;	    +==============================================================================+			 
				 boucle_my_write:
			  ; {	
					; Corps de la boucle
					  ;
						;  	+=========================================+
						;  	| CONDITION		CONDITION		CONDITION |
						;  	+=========================================+	
						;	Faire un retour chariot quand on rencontres 0xD dans la chaines de caractere.
							
								cmp		[ecx], byte 0xD 
								jne		no_carriage_return_my_write
							  ; {
									carriage_return_my_write:
										inc		ecx		; Caractere suivant
									new_line_my_write:										
										add		si, 2*80	; Explication: '80' reprsente les 80 carateres maxi que peut compos une ligne de MON cran
															; , peut-etre que votre rsolution d'cran permet d'afficher plus de caractere sur une ligne, 
															; par consquent changer la valeur '80' en fonction de votre maxi.
															; Et fois 2, car un caractere est cod sur 2 octet.
								;  	+=========================================+
								;  	| CONDITION		CONDITION		CONDITION |
								;  	+=========================================+	
									; Si dans la ligne (dsign par 'ax') que l'on a saut contient des caracteres on saute de nouveau une ligne  
									
										cmp		di, si	; pour cela on regarde si on  pas dj parcourue la nouvelle ligne, indique par le "pointeur" 'di'.
										jb		no_new_line_my_write  
										;{
												jmp		new_line_my_write	
										;}	
										no_new_line_my_write:
									
								; 	+========================================+
								; 	|	END_CONDITION		END_CONDITION	 |
								;	+========================================+
									cmp		[ecx], byte 0xD		 ; Regarde si de nouveau le caratere suivant n'est pas un retour chariot
									je		carriage_return_my_write
									mov		di, si
							  ; }
								no_carriage_return_my_write:
								
						; 	+========================================+
						; 	|	END_CONDITION		END_CONDITION	 |
						;	+========================================+
						; 	Ecrire  l'cran	
							;				
								; algo pour 'ah': {0}= clignotement {000}=couleur de l'arrire plan  {1}=surintensit {111}=couleur du texte
								mov		al, [ecx]
								stosw	; mov	[ES:DI], ax	\n   add	di, 2
									
					; Test de la boucle
					inc	 ecx
					cmp	 ecx, [param_my_write + 4]	; dword limite
				 jne	 boucle_my_write	
			  ; }
		;		+==========================================================================+
		;		| END_BOUCLE	 END_BOUCLE		END_BOUCLE		END_BOUCLE   	END_BOUCLE |
		;		+==========================================================================+	
	ret
	 ;=============
	 ; /my_write
	 ;=============
	 ; ------------------------------------------------------------------
; os_speaker_tone -- Generate PC speaker tone (call os_speaker_off to turn off)
; IN: AX = note frequency; OUT: Nothing (registers preserved)

os_speaker_tone:


	mov cx, ax			; Store note value for now

	mov al, 182
	out 43h, al
	mov ax, cx			; Set up frequency
	out 42h, al
	mov al, ah
	out 42h, al

	in al, 61h			; Switch PC speaker on
	or al, 03h
	out 61h, al


	ret


; ------------------------------------------------------------------
; os_speaker_off -- Turn off PC speaker
; IN/OUT: Nothing (registers preserved)

os_speaker_off:


	in al, 61h
	and al, 0FCh
	out 61h, al


	ret


; ==================================================================
Keywait:
	; Le composant 8042 est accesible via les port 0x64 et 0x60, le port 0x64 sert  envoy des commandes vers le controlleur 8042.
	; Et le port 0x60 sert  envoyer les parmatres que la commande attend. Bien sur ces ports sont piloter en sortie (out).
	mov		al, 0xD2	; (Write keyboard buffer) - Parameter written to input buffer as if received from keyboard.
						;							traduc: Les parametres sont crit dans le buffer d'entre (accesible au port 0x60 en entre) 
						;							comme s'il le (buffer) recevait depuis les touches du clavier
	out		64h, al     	
	; BreakCodes= KeyUp	
	; MakeCodes= KeyDown
	; Scancode: |7|6|5|4|3|2|1|0|
	;			 | |_|_|_|_|_|_|_ -->{Scancode}
	;			 |
	;			 |--> '1'= BreakCodes '0'= MakeCodes
	mov		al, 0x80	; al=10000000b
	out		60h, al  
	
	keyup:
		in		al, 0x60
		and	 	al, 10000000b
	jnz		keyup	; Si le 8eme bit == 1 Alors sauter  keyup
	Keydown:
	in		al, 0x60
ret
;================================================================================================
;END_FONCTIONS	END_FONCTIONS	END_FONCTIONS	END_FONCTIONS	END_FONCTIONS	END_FONCTIONS
;================================================================================================

;================================================================================================
;CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE
;================================================================================================

	main:
			;-----------------------------recuparation de l'unit, du mdias de stockage, qui contient ce code
			mov 	byte [bootdev], dl 

			;--------Enable A20 with 8042.   
			
			in 		al, 0x92
			or 		al, 2
			out		 0x92, al
			
	
			; xor		ah, ah
			; pusha
			; call		0xF000:0xE82E		; --> int 0x16
			; popa
			
			; pusha
			; call		0xF000:0x5EE9		; --> int 0x13
			; popa				
			
	 		; mov		ax, 0x4F02 
			; mov		bx, 0x0115 
			; pusha
			; call		0x0C00:0014		; --> int	0x10
			; popa


			;-----------------------------	 
			; fonction_n_1:
			; ---------------------------------------------paramatres passer  my_write
				 mov 	[param_my_write], dword msg
				 mov 	[param_my_write + 4], dword end_msg		; Adresse de fin de msg 
			call	my_write

	; -------------------- Attent la pression d'une touche puis on continue ---

		call	Keywait

	;	 ____________________________________________________________________________________________________________________________________ 
	;	|																																	 |
	;	|		Facultatif. Cette fonction (int 13h) appelle un kernel ou programme sur le secteur que l'on a dfinie 						 |
	;	|		avec : mov 	dl,__	sur l'unit que le bios a trouv lors du boot: mov	dl,[Drive];									 		 |
	;	|____________________________________________________________________________________________________________________________________|
	;	|																																	 |
	;	|	---------------------------reset_disk_system																				     |
			 xor 	ax, ax			;																										 |
			 mov 	dl, [bootdev]   ; 																										 |
			 int 	0x13  			;																										 |
	;   |																																	 |
	;	|																																	 |
	;	|	--------------------read_sector_into_memory ( charge le noyau)																	 |
			 mov 	ax, BASE	;																											 |
			 mov 	es, ax		;																											 |
			 xor	bx, bx		;																											 |
	;	|																																	 |
	;	|																																	 |
	;	|	------------------- Effectuer la lecture du lecteur en mode CHS (Cylindre Head Sector) o le kernel se trouve					 |
			 mov 	ah, 2				; Fonctions 02h de int 13h																			 |
			 mov 	al, nbr_sector		; Charge nbr_sector secteurs (1 secteur = 512 octet)												 |
			 xor 	ch, ch				; Cylinder=0																						 |
			 mov 	cl, 2				; Sector=2																							 |
			 xor 	dh, dh				; Head=0																							 |
			 mov 	dl, [bootdev]		; Drive														;										 |
			 int 0x13																				;										 |
	;	|																							;										 |
	;	|	--------------------- Attach_process at 1000:0000																				 |
			 jmp	 dword BASE:0		;																									 |
	;	|___________________________________________________________________________________________________________________________________ |
	;	|																																	 |
	;	|____________________________________________________________________________________________________________________________________|


	;-------------------------------ICI on rempli le binaire finale 0 pour arriver a 510 octet.
	 times 510-($-$$) db 0 	; '$' correspond a l'adresse du dbut du code .
							; '$$' correspond a l'adresse o l'instruction times se trouve.
							; Ainsi ($-$$) correspond  la portion de code en octet entre le dbut du code jusqu'a 'times'.

	; Puis on ajoute le mot 0x55AA, qui correspond au mot magique (sur 2 octet) ce qui fait 512 octet au final :)
	; Cela permet au BIOS de copier les 512 octet du fichier binaire en 0000:7C00,
	; puis il saute (jmp 0000:7C00)  cette adresse pour l'excuter. 
	dw 0xAA55

;================================================================================================
;END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	
;================================================================================================

;*Hacker's emblem:				*Art Ascii:
;	|_|0|_|						;	(\___/)
;	|_|_|0|						;	(='.'=)
;	|0|0|0|						;	(")_(")
								;This is Bunny. Copy and paste bunny into...
								;...your signature to help him gain world domination

;  _____________________________________________________________________
; 88.._|      | `-.  | `.  -_-_ _-_  _-  _- -_ -  .'|   |.'|     |  _..88
; 88   `-.._  |    |`!  |`.  -_ -__ -_ _- _-_-  .'  |.;'   |   _.!-'|  88
; 88      | `-!._  |  `;!  ;. _______________ ,'| .-' |   _!.i'     |  88
; 88..__  |     |`-!._ | `.| |_______________||."'|  _!.;'   |     _|..88
; 88   |``"..__ |    |`";.| i|_|MMMMMMMMMMM|_|'| _!-|   |   _|..-|'    88
; 88   |      |``--..|_ | `;!|l|MMoMMMMoMMM|1|.'j   |_..!-'|     |     88
; 88   |      |    |   |`-,!_|_|MMMMP'YMMMM|_||.!-;'  |    |     |     88
; 88___|______|____!.,.!,.!,!|d|MMMo * loMM|p|,!,.!.,.!..__|_____|_____88
; 88      |     |    |  |  | |_|MMMMb,dMMMM|_|| |   |   |    |      |  88
; 88      |     |    |..!-;'i|r|MPYMoMMMMoM|r| |`-..|   |    |      |  88
; 88      |    _!.-j'  | _!,"|_|M)(MMMMoMMM|_||!._|  `i-!.._ |      |  88
; 88     _!.-'|    | _."|  !;|1|MbdMMoMMMMM|l|`.| `-._|    |``-.._  |  88
; 88..-i'     |  _.''|  !-| !|_|MMMoMMMMoMM|_|.|`-. | ``._ |     |``"..88
; 88   |      |.|    |.|  !| |u|MoMMMMoMMMM|n||`. |`!   | `".    |     88
; 88   |  _.-'  |  .'  |.' |/|_|MMMMoMMMMoM|_|! |`!  `,.|    |-._|     88
; 88  _!"'|     !.'|  .'| .'|[@]MMMMMMMMMMM[@] \|  `. | `._  |   `-._  88
; 88-'    |   .'   |.|  |/| /                 \|`.  |`!    |.|      |`-88
; 88      |_.'|   .' | .' |/                   \  \ |  `.  | `._    |  88
; 88     .'   | .'   |/|  /                     \ |`!   |`.|    `.  |  88
; 88  _.'     !'|   .' | /                       \|  `  |  `.    |`.|  88
; -----------------------------------------------------------------------

;    )\._.,--....,'``.
;   /,   _.. \   _\  ;`._ ,.
;  `._.-(,_..'--(,_..'`-.;.'




          ; .-,        <,`-.__.-'>
         ; / |          )       (
         ; | ;         /_   ^4^  \_
         ; \  \.-~~-.__\=_  -'- _/=
          ; \             `---;`
          ; /    |            |__
        ;     /    ,    |  /  `~.
        ; |    .'~..__|    /.' `'~,_)
        ; T  (`  |  ( ;   |
         ; \  \   '._) \  \_
          ; '._)        ',__)
;J'espre que cela a t une prcieuse aide dans vos recherches :)
