[ORG 0x1000]

		
jmp		main

; Lien pour le Vesa:
	; http://www-evasion.imag.fr/Membres/Antoine.Bouthors/teaching/dos/vesa.fr.html
; Lien pour la GDT:	
	; http://www.internals.com/articles/protmode/protmode.htm
;================================================================================================
;DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA	DATA
;================================================================================================
	%define		TRAM 	 	0x0B8000	; [T]ext[RAM] adresse du dbut de la zone mappe qui est la mmoire vido, mais en mode texte et non graphique (pixel) .
	%define		VRAM 	 	0x0A0000 	; [V]ideo[RAM] idem, mais cette fois ci en mode graphique (pixel) .
	
	%include "1.ASM/cmd[].asm"
	
						;0    2    4       6 8    0	   2	   4    6    8
	Date		db		'JJ','/','MM','/','20AA',' ','HH',':','MM',':','SS',0x0D
						; 1		  3    5    7 9		  1    3	5	    7
	end_Date:
	
	var_a		db		1
	
	input		db		0,0xD
	end_input:
	
	Windows.title	db	'TITRE'
				
	param_my_write		dd		0 	; char* tampon
						dd		0	; dword limite
						
	windows_length		dd		0
	windows_width		dd		0 
	
	msg 		db		0,0xD
	end_msg:
		
	; Ici commence la modification des touches du clavier 

	; Pour comprendre ce que j'ai fait, il faut d'abord que vous sachiez que le contrleur 8042 du clavier renvoie le numro de la touche, appel aussi scancode, 

	; lorsqu'une touche a t appuye, pour voir les correspondances go to "ntouche_azerty.asm" situe dans "ASM/NASM/1.ASM/" 
	
	; L je fais simplement une redifinit de la disposit des touches pour mettre le clavier en AZERTY :)
	azerty		db		0,0x1B,'&"',0x27,'(-_)=',0x8,0x9	; touche n0-->15 	0x1B --> Escape	 	|	0x27 --> '
				db		'azertyuiop'							; touche n16-->25 	0x8 --> Backspace	 	|	0x9 --> TAB
				db		'^$',0xD,0x11 							; touche n26-->29 	0xD --> Enter		 	|	0x11 --> CTRL
				db		'qsdfghjklm'							; touche n30-->39 	0xF --> Shift left	|	0x12 --> ALT
				db		'',0xF,'*'  							; touche n40-->43 	0x20 --> SPACE
				db		'wxcvbn,;:!'							; touche n44-->53 
				db		0xF,'*',0x12,0x20,0xF,0xF				; touche n54-->59			 				
	
	AZERTY		db		0,0x1B,'1234567890+',0x8,0x9
				db		'AZERTYUIOP'
				db		'',0xD,0x11
				db		'QSDFGHJKLM'
				db		'%',0xE,''						; 0xE --> Shift left
				db		'WXCVBN'
				db		'?./',0xE,'*',0x12,0x19,0xE,0xE	; la derniere valeur correspond  la touche F1

	Shift		dd		azerty 	; Par default on est en minuscule
	
	
	; Ne pas oublier de mettre 0xD  la fin de la chaine de caractere
	; msg 	db			'LOADING BOOTLOADER....OK',0xD,'Hello World! :)',0xD,'Appuyer sur une touche pour charger le kernel',0xD
	; end_msg:	
	

	; Note: Les decriptions dans cet mini-documentation provient de: 
	;		"Intel 64 and IA-32 Architectures Software Developer's Manuel Volume 3A.pdf"
	;		URL: http://www.intel.com/content/www/us/en/architecture-and-technology/64-ia-32-architectures-software-developer-vol-3a-part-1-manual.html
	;	Paginer: Action de numroter page par page un registre, un cahier, un livre. Definition de wikipedia
	
; GLOBAL DESCRIPTORS TABLE
			
	; Donc on arrive  la GDT, mais quesako la GDT O_o ?

; GESTION DE LA MEMOIRE:

	; Tout d'abord gestion de la mmoire est ralis par le MMU (Memory management unit = unit de gestion mmoire)
	; intgre de nos jour dans les  . 
	; Il y  en tout, deux thechnique de gestion possible pour la mmoire:  
	; 	* Sa segmentation (GDT et IDT qui la gerent) 
	; 	* Sa pagination (rpertoire et tables des pages qui la gerent) optionnel
	;
	;	IA-32e mode = 64 bits mode  
	;
	; Grae  ces deux mecanismes on peut faire un systme multitaches.
	; En 16 bits les registres et adresses sont sur 16 bits maximum, mais on peut utiliser les registres 32 bits.
	; En 32 bits les registres et adresses sont sur 32 bits maximum
	; En 64 bits les registres et adresses sont sur 64 bits maximum
	;
	; Pour adresser une donne ou instruction on utilise trois types d'adresses:
	;	* Les adresses logiques, ce sont les adresse mmoire contenue dans un programme: segment et offset
	;	* Les adresses linaires
	;	* Les adresses physiques
	;
	;	La conversion des adresses logiques en adresses linaires s'effectue grae au mecanisme de
	;	la segmentation.
	;
	;	La conversion des adresses linaires en adresses physique s'effectue graa au mecanisme de 
	;	la pagination. S'il n'est pas active alors adresses linaires = adresses physique.
	
; I/ SEGMENTATION

	; La segmentations est un mcanisme, qui permet de diviser la mmoire (RAM) en plusieurs blocs. Totalement 
	; individuelle les uns des autres, ces blocs appels segment, ont une taille, fixe en mode rel de 64 Ko 
	; mais variable pour les autres modes. 
	;  
	; La variation de la taille des secteurs est donne grae  des descripteur de segments contenue dans un tableau
	; (GDT = Global Descriptors Table), Il y a en tout: 2^13 = 8192 descripteurs, l'adresse d'un descripteur est mis dans 
	; un registre de segment.
	;
	;  les registres CS et SS contiennent le CPL (current privilege level) qui est normalement gale  RPL
	;
	;   Slcteur de segment (CS/DS/ES/FS/GS/SS):
	;	 _______________________________________________________________________________
	;   | 15 | 14 | 13 | 12 | 11 | 10 | 9  | 8  | 7  | 6  | 5  | 4  | 3  | 2  | 1  | 0  |
	;	|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|
	;	|								                                 |    |         |
	;	|            Index = Adresse d'un descripteur de la GDT          | TI |   RPL   |
	;	|________________________________________________________________|____|_________|
	;																		|	   |_Requested Privilege Level	
	;																		|					
	;																		|_Table Indicator ( 0 = GDT ; 1 = LDT)
	;
	;	Valeur pour RPL: indique  quel niveau de privilge doit fonctionner le segment
	;	* 0 = Operating System Kernel
	;	  1 = Operating Services
	;	  2 = Operating Services
	;	  3 = Applications
	;   * 'Table Indicator' indique quel table, GDT ou LDT=Local Descriptor table, sera utilise pour dcrire les segments
	;	* Index = Adresse du descripteur choisi.
	;
	; Dans le mode rel, le programmeur peut aisment choisir son segment en usant des registres de segment:
	;
	;*Registre de Segment mmoire:
	;
	;	CS(16 bits) : Segment mmoire, du code par convention
	;	DS(16 bits) :   ""      ""     des donnes par convention
	;	ES(16 bits) :   ""      ""        ""			""
	;	FS(16 bits) :   ""      ""        ""			""
	;	GS(16 bits) :   ""      ""        ""			""
	;	SS(16 bits) :   ""      ""     de la pile par convention
	;
	; Ces registres slectionne le segment (16 bits) qui nous interresse, et ainsi on peut mofifier les donnes  l'interieur de ce segment.
	; Et pour ce dplacer  l'interieur on utilise des registres d'Offset (32 bits): 
	;
	;*Registre d'Offset mmoire: * = Ces registre ne sont accsible qu'en mode 64 bits
	;	
	;	DIL(*8 bits)/DI(16 bits)/EDI(32 bits)/RDI(*64 bits) : utilis avec ES pour les oprations de chaines de caractere ou  I/O pointer.
	;	IPL(*8 bits)/IP(16 bits)/EIP(32 bits)/RIP(*64 bits) : Instruction Pointer, pointeur d'instruction (inaccessible directement, modifiable indirectement 
	;														  avec l'instruction CALL, JMP, ou J[flags]). 
	;	BPL(*8 bits)/BP(16 bits)/EBP(32 bits)/RBP(*64 bits) : coupl avec SS segment sur la pile, copie de SP  laquelle on soustrait une valeur pour lire dans la pile 
	;														  (on ne doit pas modifier SP).
	;	SIL(*8 bits)/SI(16 bits)/ESI(32 bits)/RSI(*64 bits) : utilis avec DS pour les oprations sur les chaines de caractre. 
	;	SPL(*8 bits)/SP(16 bits)/ESP(32 bits)/RSP(*64 bits) : Stack Pointer, pointeur de pile coupl avec le registre SS .
	;
	; La segmentation transforme ainsi une adresse logique [Segment:Offset] en adresse linaire sur 32 bits (pmode), 64 bits (long mode)
	;	* Adresse logique = (Segment x 16) + Offset .
	;	* Adresse linaire = Base Address + Offset .'Base Address' faisant partie d'un dscripteur de segment de la GDT
	; 												 En mode 32 bits 'Base Address' et 'Offset' sont en 32 bits 
	;												 En mode 64 bits 'Base Address' et 'Offset' et 'Adresse linaire' sont en 64 bits 

	
; II/PAGINATION

	; La pagination est un mcanisme, qui permet de diviser les segments en d'autres blocs encore plus petit (4 Ko ou 4 Mo) apple pages.
	; Ces pages sont soit stock en RAM ou autre support de stockage
	; Elle est utilise pour pouvoir transferer des blocs ailleurs que dans la RAM, comme par exemple le dique dur.
	; Pour pouvoir faire ce transfre on doit pouvoir connaitre l'adresse de dbut o l'on commence  copier le bloc.
	;
	; Cet adresse est donne  parir de la Tables de traduction d'adresses
	; La Pagination transforme une adresse linaire sur 64 bits en adresse physique sur 64 bits
	;
	; La GDT (Global Descriptors Table) est une tableau de 8 octet = 64 bits,
	;
	;
	; Donc pour indiquer au  quel chapitre serat utilise comme descripteur, on fait: 
	; 'jmp	chapitre:Label' o chapitre peut etre dans notre cas DATA_SELECTOR
	;											  				 CODE_SELECTOR
	;											  				 LONG_SELECTOR
	; et bien sur l'adresse du chapitre est donn  partir du label GDT et non du programme :)
	; Ce qui donne jmp	(Chapitre-GDT):Label

; 																				  LA GDT		
; I/Descripteurs:
;			
; * Descripteur d'un segment de code:	
;										       _
;											  |	G - Granularity (0 = La taille du segment peut varier de 1 o  1 Mo en RAM, une incrmentaiton de 1 o sur le segment 
;											  |					 1 = La taille du segment peut varier de 4 Ko  4 Go en RAM, une incrmentaiton de 4 ko sur le segment)
;											  |		_
;											  |	   | D - Taille par defaut des adresses mmoire et operandes des instructions (0 = operandes sur 16/8 bits et adresses sur 16-bit
;											  |    |							   		   									   1 = operandes sur 32/8 bits et adresses sur 32-bit)
;											  |	   |	 _
;											  |	   |	| L - 64-bit code segment (IA-32e mode only)
;											  |	   |    |	  _
;											  |	   |	|	 | AVL - Available for use by system software
;											  |	   |	|	 |				  		   _
;											  |	   |	|	 |						  | P= Segment Present (0 = segment not present in RAM 
;											  |	   |    |    | 						  | 					1 = segment present in RAM)
;											  |	   |	|	 |						  |
;											  |	   |	|	 |						  |		   _
;											  |	   |	|	 |						  |		  | DPL - Descriptor Privilege Level
;											  |	   |	|	 |						  |		  |	  	  _
;											  |	   |	|	 |		 	 			  | 	  |	 	 | S = Descriptor type (0 = system ; 1 = code or data)
;											  |	   |	|	 |						  |	  	  |	 	 |     	    _
;											  |	   |	|	 |						  |		  |	 	 |	   	   | C = Conforming
;											  |	   |	|	 |						  |	  	  |      |	       |     _
;											  |	   |	|	 |			     	 	  |       |      |         |    | R = Readable
;											  |	   |	|	 |					 	  |	 	  |	 	 |		   |	|	  _
;											  |	   |	|	 |					 	  |	  	  |	 	 |	       |    |    | A = Accessed  
;											  |    |    |    |						  |       |      |     ____|____|____|    
;											  |    |    |    |     					  |       |      |    /     TYPE      \
;	 _________________________________________|____|____|____|________________________|_______|______|___/_____|____|____|_\_________________________________________
;	| 63 | 62 | 61 | 60 | 59 | 58 | 57 | 56 | 55 | 54 | 53 | 52 | 51 | 50 | 49 | 48 | 47 | 46 | 45 | 44 | 43 | 42 | 41 | 40 | 39 | 38 | 37 | 36 | 35 | 34 | 33 | 32 |
;	|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|
;	|			                            |    |    |    |    |                   |	 | 	  	   |    |    |	  |	   |	|										|
;	|  			Base Address 31:24  	    | G  | D  | L  |AVL | Segm. Limit 19:16 | P  |   DPL   | S  | 1  | C  | R  | A	|	   		Base Address 23:16		    |
;	|_______________________________________|____|____|____|____|___________________|____|_________|____|____|____|____|____|_______________________________________|
;	|																				|																				|
;	|				  			  Base Address 15:00								|				  			  Segment Limit 15:00				  				|
;	|_______________________________________________________________________________|_______________________________________________________________________________|
;	| 31 | 30 | 29 | 28 | 27 | 26 | 25 | 24 | 23 | 22 | 21 | 20 | 19 | 18 | 17 | 16 | 15 | 14 | 13 | 12 | 11 | 10 | 9  | 8  | 7  | 6  |  5 |  4 | 3  |  2 |  1 |  0 |
;   |____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____| 
;
;	Base Address = Adresse sur 32 bits indiquant la location du dbut du segment dans la RAM
;	Segment Limit = Adresse sur 20 bits indiquant la location de la fin du segment dans la RAM
;
;	Code-Segment Types:
; 	 _______________________________________________________________________________________ 
;	|                               |				|										|
;	|			Type Field          |				|										|
;	|_______________________________|	Descriptor	|			  Description				|
;	|			| 43 | 42 | 41 | 40 |	  Type		|										|
;	|  Decimal	|	 |	C |	 R |  A	|				|										|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  8		| 1	 | 0  | 0  | 0  |	  Code		|	Execute-Only						|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  9		| 1	 | 0  | 0  | 1	|	  Code		|	Execute-Only, accessed				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  10	| 1	 | 0  | 1  | 0  |	  Code		|	Execute/Read						|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  11	| 1	 | 0  | 1  | 1  |	  Code		|	Execute/Read, accessed				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  12	| 1	 | 1  | 0  | 0  |	  Code		|	Execute-Only, conforming			|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  13	| 1	 | 1  | 0  | 1  |	  Code		|  Execute-Only, conforming, accessed   |
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  14	| 1	 | 1  | 1  | 0  |	  Code		|  Execute/Read, conforming				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  15	| 1	 | 1  | 1  | 1  |	  Code		|  Execute/Read, conforming, accessed  	|
;	|___________|____|____|____|____|_______________|_______________________________________| 

; * Descripteur d'un segment de donne:	
;										       _
;											  |	G - Granularity (0 = La taille du segment peut varier de 1 o  1 Mo en RAM, une incrmentaiton de 1 o sur le segment 
;											  |					 1 = La taille du segment peut varier de 4 Ko  4 Go en RAM, une incrmentaiton de 4 ko sur le segment)
;											  |		_
;											  |	   | B - taille par dfaut du pointeur de pile (0 = La pile est sur 16 bits: SP
;											  |    |								 			1 = La pile est sur 32 bits: ESP)
;											  |	   |	 _
;											  |	   |	| L - 64-bit code segment (IA-32e mode only)
;											  |	   |    |	  _
;											  |	   |	|	 | AVL - Available for use by system software
;											  |	   |	|	 |				  		   _
;											  |	   |	|	 |						  | P= Segment Present (0 = segment not present in RAM 
;											  |	   |    |    | 						  | 					1 = segment present in RAM)
;											  |	   |	|	 |						  |
;											  |	   |	|	 |						  |		   _
;											  |	   |	|	 |						  |		  | DPL - Descriptor Privilege Level
;											  |	   |	|	 |						  |		  |	  	  _
;											  |	   |	|	 |		 	 			  | 	  |	 	 | S = Descriptor type (0 = system ; 1 = code or data)
;											  |	   |	|	 |						  |	  	  |	 	 |     	    _
;											  |	   |	|	 |						  |		  |	 	 |	   	   | E = Expand-down
;											  |	   |	|	 |						  |	  	  |      |	       |     _
;											  |	   |	|	 |			     	 	  |       |      |         |    | W = Writable
;											  |	   |	|	 |					 	  |	 	  |	 	 |		   |	|	  _
;											  |	   |	|	 |					 	  |	  	  |	 	 |	       |    |    | A = Accessed  
;											  |    |    |    |						  |       |      |     ____|____|____|    
;											  |    |    |    |     					  |       |      |    /     TYPE      \
;	 _________________________________________|____|____|____|________________________|_______|______|___/_____|____|____|_\_________________________________________
;	| 63 | 62 | 61 | 60 | 59 | 58 | 57 | 56 | 55 | 54 | 53 | 52 | 51 | 50 | 49 | 48 | 47 | 46 | 45 | 44 | 43 | 42 | 41 | 40 | 39 | 38 | 37 | 36 | 35 | 34 | 33 | 32 |
;	|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|
; 	|			                            |    |    |    |    |                   |	 | 	  	   |    |    |	  |	   |	|										|
;	|  			Base Address 31:24  	    | G  | B  | L  |AVL | Segm. Limit 19:16 | P  |   DPL   | S  | 0  | E  | W  | A	|	   		Base Address 23:16		    |
;	|_______________________________________|____|____|____|____|___________________|____|_________|____|____|____|____|____|_______________________________________|
;	|																				|																				|
;	|				  			  Base Address 15:00								|				  			  Segment Limit 15:00				  				|
;	|_______________________________________________________________________________|_______________________________________________________________________________|
;	| 31 | 30 | 29 | 28 | 27 | 26 | 25 | 24 | 23 | 22 | 21 | 20 | 19 | 18 | 17 | 16 | 15 | 14 | 13 | 12 | 11 | 10 | 9  | 8  | 7  | 6  |  5 |  4 | 3  |  2 |  1 |  0 |
;   |____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____| 
;																					  
;											   
;	Base Address = Adresse sur 32 bits indiquant la location du dbut du segment dans la RAM
;	Segment Limit = Adresse sur 20 bits indiquant la location de la fin du segment dans la RAM
;
;	Il y a un autre descripteur de segment de donne 'Expand-down', le 54 eme bit  est aussi appele le drapeaux B 
;	( 1 = Upper bound is 4 Go ; 0 = Upper bound is 64 Ko )
;	
;	Data-Segment Types:
; 	 _______________________________________________________________________________________ 
;	|                               |				|										|
;	|			Type Field          |				|										|
;	|_______________________________|	Descriptor	|			  Description				|
;	|			| 43 | 42 | 41 | 40 |	  Type		|										|
;	|  Decimal	|	 |	E |	 W |  A	|				|										|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  0		| 0  | 0  | 0  | 0  |	  Data		|	Read-Only							|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  1		| 0	 | 0  | 0  | 1	|	  Data		|	Read-Only, accessed					|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  2		| 0	 | 0  |	1  | 0  |	  Data		|	Read/Write							|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  3		| 0	 | 0  |	1  | 1  |	  Data		|	Read/Write, accessed				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  4		| 0	 | 1  | 0  | 0  |	  Data		|	Read-Only, expand-down				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  5		| 0	 | 1  | 0  | 1  |	  Data		|	Read-Only, expand-down, accessed	|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  6		| 0	 | 1  | 1  | 0  |	  Data		|	Read/Write, expand-down				|
;	|___________|____|____|____|____|_______________|_______________________________________|
;	|	   		|	 |	  |	   |	|	   			|										|
;	|	  7		| 0	 | 1  | 1  | 1  | 	  Data		|	Read/Write, expand-down, accessed	|
;	|___________|____|____|____|____|_______________|_______________________________________| 

; La Pagination
;
; 	La pagination n'est pas utilise quant CR0.PG = 0 . Le  traite toutes les adresse linaire
;	comme si elles taient de adresse physique (prsente dans la RAM).

;	La pagination est utilise quant CR0.PG = 1 et CR0.PE = 1 . 
;	Ainsi si c'est le cas, un des 3 modes de pagination ci-dessous est accsible:
;
;		* 32-bit paging (CR0.PG = 1 et CR4.PAE = 0). Linear-Address Width = 32 bits. 
;													 Physical-Address Widht = 40 bits.
;													 Page Size = 4 Ko ou 4 Mo<--(CR4.PSE = 1).

;		* PAE paging	(CR0.PG = 1 et CR4.PAE = 1 et IA32_EFER.LME = 0). Linear-Address Width = 32 bits. 
;													 					  Physical-Address Widht = 52 bits.
;																		  Page Size = 4 Ko ou 2 Mo.

;		* IA-32e paging (CR0.PG = 1 et CR4.PAE = 1 et IA32_EFER.LME = 1). Linear-Address Width = 48 bits.
;													 					  Physical-Address Widht = 52 bits.
;													 					  Page Size = 4 Ko ou 2 Mo ou 1 Go
;	
; le mode IA-32e (64 bit) contient deux sous-modes:
;
;		* Le mode compatible. Ce mode utilise des adresse lineaire sur 32 bits.  
;
;		* Le mode 64-bit. Ce mode utilise des adresse lineaire sur 64 bits.
;
;
; 

	GDT64:	
		NULL_SELECTOR:	; null selector sur 64 bits		
						dw 	GDT_LENGTH		; limit of GDT 
						dw 	GDT64			; linear address of GDT
						dd 	0x0			
		CODE_SELECTOR:	; 32-bit code selector (ring 0)
						dw 	0x0FFFF			; Segment Limit 15:00
						db	0x0, 0x0, 0x0	; Base Address 23:00
						db  10011010b		;	|7|6|5|4|3|2|1|0|
											;	 | | | | | | | `----- Le bit A est mis  1 par le processeur quand le segment est utilis. 
											;	 | | | | | | `------ Le bit R est mis  1 pour indiquer que le segment de code est accessible en lecture 
											;	 | | | | | `------- Le bit C indique si le segment de code est "conformant" ou non. Pour le moment, ce bit sera mis  0. 
											;	 | | | | `-------- 1
											;	 | | | `--------- le bit S est mis a 1 pour un descripteur de segment et a 0 pour un descripteur systme
											;	 | | `---------- le DPL indique le niveau de privilge du segment. Le niveau 0 correspond au mode super-utilisateur. 
											;	 | `----------- DPL (2/2)
											;	 `------------ le bit P est utilis pour dterminer si le segment est prsent en mmoire physique. Il est  1 si c'est le cas. 
						db	11001111b		;	|7|6|5|4|3|2|1|0|
											;	 | | | | | | | `----- Limite 16
											;	 | | | | | | `------ Limite 17
											;	 | | | | | `------- Limite 18
											;	 | | | | `-------- Limite 19
											;	 | | | `--------- le bit AVL est librement disponible.
											;	 | | `---------- 0
											;	 | `----------- le bit D/B prcise la taille des instructions et des donnes manipules. Il est mis  1 pour 32 bits.
											;	 `------------ si le bit G est  0, la limite est exprime en octets, sinon, elle est exprime en nombre de pages de 4 ko.
						db	0x0				; Base Address 31:24
						
		DATA_SELECTOR:	; flat data selector (ring 0)		
						dw 	0x0FFFF			; Segment Limit 15:00
						db	0x0, 0x0, 0x0	; Base Address 23:00
						db  10010010b		;	|7|6|5|4|3|2|1|0| 
											;	 | | | | | | | `----- Le bit A est mis  1 par le processeur quand le segment est utilis. 
											;	 | | | | | | `------ Le bit W est mis  1 pour indiquer que le segment est accessible en criture
											;	 | | | | | `------- Le bit E indique le sens d'expansion des donnes. Il est mis  1 pour un segment de type "pile" 
											;	 | | | | |		   		dans lequel les donnes s'accumulent vers le dbut de la mmoire (expand-down segment).
											;	 | | | | `-------- 1			
											;	 | | | `--------- le bit S est mis a 1 pour un descripteur de segment et a 0 pour un descripteur systme 	
											;	 | | `---------- le DPL indique le niveau de privilge du segment. Le niveau 0 correspond au mode super-utilisateur. 
											;	 | `----------- DPL (2/2)
											;	 `------------ le bit P est utilis pour dterminer si le segment est prsent en mmoire physique. Il est  1 si c'est le cas. 
						db	10001111b		; Idem que CODE_SELECTOR
						db	0x0				; Base Address 31:24
						
		LONG_SELECTOR:	; 64-bit code selector (ring 0)
						dw 	0x0FFFF			;  Segment Limit 15:00
						db	0x0, 0x0, 0x0	; Base Address 23:00
						db  10011010b		; 
						db	10101111b		; Idem que CODE_SELECTOR
						db	0x0				; Base Address 31:24
	GDT_LENGTH:	
;================================================================================================
;END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA	END_DATA
;================================================================================================

;========================================================================================================
;FONCTIONS		FONCTIONS		FONCTIONS		FONCTIONS		FONCTIONS		FONCTIONS		FONCTIONS	
;========================================================================================================
[BITS 64]

	
	;***************************************************************************************************************************		
	;=============
	 ; my_read
	 ; Synopsie: Lit un caractere provenant du clavier via le controlleur 8042 et le stocke dans 'al'.
	 ; Entre : touche_clavier 
	 ; Sotie: param_my_write
	 ;=============						
	my_read:	
				call	Keywait		
				

			;  	+=========================================+
			;  	| CONDITION		CONDITION		CONDITION |
			;  	+=========================================+		
			; 	Vrification de l'tat des touches BackSpace et Enter
			
					cmp		al, 14
					je		Backspace		; Efface le caractere prscedant
					
					cmp		al, 28			; En clair si la touche 'entre' est enfonc 
					je		check_cmd 		; on va vrifie si prscedement dans le buffer video on n'a pas ecris une des commande rpertori dans cmd[]				
			
			;	+========================================+
			;	|	END_CONDITION		END_CONDITION	 |
			;	+========================================+	
	
				; Or si vous regardez la table ASCII (cf: Google), le code retourn ne peut tre affich correctement :) alors que fait-on ?, et bien comme 

				; vous l'avez-vu prcdemment il y a 2 tableau: ASCII[] et ascii[] qui vont servir de correspondance aux touches appuyes . 

				; Je m'explique, le scancode qui est dans 'al' sera ajout  notre adresse dsigne par ascii ou ASCII[] (label) et la somme dsignera un nombre qui sera 

				; quivalent aux touches presses. Explicat : tableau[] --> 0x500 ; tableau[1] --> tableau+1 --> 0x501 

				; Ex: si on appuie sur A, al vaudra 16(10), quand on ajoute 16  l'indice de tableau ascii[] ou ASCII[], 
				; cela donne ascii[16] ou ASCII[16], donc ascii+16 ou ASCII+16 

				; Maintenant toujours dans l'exemple allez vrifier dans les tableaux si on a bien le 'a' attendue  l'adresse ascii+16 et ASCII+16, 
				; pour rappel le label 'ascii' reprsente les minuscules et le label 'ASCII' les majuscules.
				
				;============================================================================
				;--------------Gestionnaire de minuscule et MAJUSCULE en azerty ;)-----------
				;============================================================================

					cmp		al, 0x3A		; Bouton CapsLock 
					jne		end_qwerty_azerty	
				; if([Shift]=="AZERTY")  // shift_in
				; { 	
						cmp		[Shift], dword AZERTY
						je		shift_out
							mov		[Shift], dword AZERTY		; On passe en MAJUSCULE
							jmp		my_read	
				; }		
				shift_out:			
				; else	// shift_out
				; {			
						mov		[Shift], dword azerty		; On passe en minuscule
						jmp		my_read				
				; }
					end_qwerty_azerty:
				;============================================================================
				;-----------------------------Fin  de gestionnaire---------------------------
				;============================================================================					
					and		eax, 0xFF	; Ecrase la partie haute de eax, les 32 bits du haut 
					mov		esi, [Shift]
					add		esi, eax	; Ajout le nombre que la touche a renvoy lors de son appui  l'adresse du tableau stock dans 'esi'
					mov		al, [esi]	; On stocke le caractere

				;   Ici la sauvegarde des param. de la fonction: word my_write(char* tampon, int n) dans le tableau dword 'param_my_write'
					mov		[input], al								; al contient le Scan Code traduit en caractere ascii	
					mov		ah, 00111000b							; Couleur d'criture		
					mov 	[param_my_write], dword input			; empile l'adresse de input[1] : &input en C
					mov 	[param_my_write + 4], dword end_input	
			; On affiche 
				call	my_write	
	jmp		my_read
	 ;=============
	 ; /my_read
	 ;=============
;===========================================================================================================	 
;===========================================================================================================	 
	;=============
	 ; my_write
	 ; Affiche une chaine de caractere  l'cran
	 ; Entre : param_my_write = adresse se la chaine  afficher sur 4 octet
	 ;			param_my_write+4 = pointeur de fin de chaine
	 ;			AH = Couleur d'criture
	 ;			EDI = Coordone de l'cran o commence l'criture
	 ; Sotie: Ecran
	 ;=============

	my_write:	; int my_write (char* tampon, dword limite, char* color );
	
				; ECX --> pointeur sur le tampon de la chaine de caractere  afficher
				; [param_my_write + 4] --> limite d'octet  transferer
				; SI --> n de lignes  l'cran ( 1 ligne = 80 words ceci est du au mode d'affichage lorsque le BIOS passe la main  notre Bootloader)	
					mov		r9d, TRAM 		; n de la ligne	
				;
				; Rcupration des parametres
					mov 	r8d, [param_my_write]		; char * tampon
				;  algo pour 'ah': {0}= clignotement {000}=couleur de l'arrire plan  {1}=surintensit {111}=couleur du texte
				; 					1= clignote		 000 noir	 100 rouge			   1=surintensit	000 noir	100 rouge		1000 gris fonc		1100 rouge clair
				; 					0= none			 001 bleu	 101 magenta		   0=none			001 bleu	101 magenta		1001 bleu clair		1101 magenta clair
				;									 010 vert	 110 brune								010 verte	110 brune		1010 vert clair		1110 jaune
				; 									 011 cyan	 111 gris clair							011 cyan	111 gris clair	1011 cyan clair		1111 blanche
				;								  
				; 																					
		;		+==============================================================================+
		;		|		BOUCLE		BOUCLE		BOUCLE		BOUCLE		BOUCLE		BOUCLE	   |
		;		+==============================================================================+
				 					
				 boucle_my_write:
			  ; {	
					; Corps de la boucle
					  ;
						;  	+=========================================+
						;  	| CONDITION		CONDITION		CONDITION |
						;  	+=========================================+	
						;	Faire un retour chariot quand on rencontres 0xD dans la chaines de caractere.
							
								cmp		[r8d], byte 0xD 
								jne		no_carriage_return_my_write
							  ; {		
									new_line_my_write:
									inc		r8d		; Caractere suivant							  
							  		; On test si on n'a pas atteint la fin de la chaine de caractere
									cmp		r8d, [param_my_write + 4]	; dword limite	
									jne		new_line_my_write2
										ret
									new_line_my_write2:										
										add		r9d, 2*80	; Explication: '80' reprsente les 80 carateres maxi que peut compos une ligne de MON cran
															; , peut-etre que votre rsolution d'cran permet d'afficher plus de caractere sur une ligne, 
															; par consquent changer la valeur '80' en fonction de votre maxi.
															; Et fois 2, car un caractere est cod sur 2 octet.								
								;  	+=========================================+
								;  	| CONDITION		CONDITION		CONDITION |
								;  	+=========================================+	
									; Si dans la ligne (dsign par 'ax') que l'on a saut contient des caracteres on saute de nouveau une ligne  
									
										cmp		edi, r9d	; pour cela on regarde si on  pas dj parcourue la nouvelle ligne, indique par le "pointeur" 'di'.
										jb		no_new_line_my_write  
										;{
												jmp		new_line_my_write	
										;}	
										no_new_line_my_write:
									
								; 	+========================================+
								; 	|	END_CONDITION		END_CONDITION	 |
								;	+========================================+
									cmp		[r8d], byte 0xD		 ; Regarde si de nouveau le caratere suivant n'est pas un retour chariot
									je		new_line_my_write
									mov		edi, r9d
							  ; }
								no_carriage_return_my_write:
								
						; 	+========================================+
						; 	|	END_CONDITION		END_CONDITION	 |
						;	+========================================+
						; 	Ecrire  l'cran	
							;				
								mov		al, [r8d]
								stosw	; mov	[ES:DI], ax	\n   add	di, 2
					; Test de la boucle
					inc	 r8d
				 jmp	 boucle_my_write	
			  ; }
		;		+==========================================================================+
		;		| END_BOUCLE	 END_BOUCLE		END_BOUCLE		END_BOUCLE   	END_BOUCLE |
		;		+==========================================================================+	
	 ;=============
	 ; /my_write
	 ;=============
	;***************************************************************************************************************************	
					
	Backspace:	; void Backspace (word es, word di);
				;  	+=========================================+
				;  	| CONDITION		CONDITION		CONDITION |
				;  	+=========================================+						
				;   Conserver le prompt
					cmp		edi, TRAM+2*80+2
					je		my_read
				   ;{
						sub		edi, 2	
						mov		ax, 0x3820	; On revient  l'adresse du caractre prcdent. 
						stosw		 		; NULL CHAR en blanc sur fond noir
						sub		edi, 2
				   ;}
				;	+========================================+
				;	|	END_CONDITION		END_CONDITION	 |
				;	+========================================+
	jmp		my_read

	;***************************************************************************************************************************	
	
	cls:	; void cls (void);
			; Alors dans cette fonction, on fait met en place le backgroud de l'OS
		
				mov 		edi, TRAM				
				; Draw Bar TOP Grey					 
					mov 	rcx, 0x12
					mov 	rax, 0x07DB07DB07DB07DB	; caractere 0xDB de la table ASCII | 0x07 --> texte en gris clair et arriere plan en noir
				rep 	stosq
				
				; Write Title : HACKOS
					mov		rax, 0x744B744374417448
				stosq
					mov		rax, 0x07DB7453744F07DB
				stosq
				
				; Draw Background Cyan	
					mov 	rcx, 0x14*23
					mov 	rax, 0x3820382038203820	; 0x20 --> espaces | 0x20 --> texte en cyan clair et arriere plan en noir
				rep 	stosq  
				
				; Draw Bar Bottom Grey					 
					mov 	rcx, 0x14
					mov 	rax, 0x07DB07DB07DB07DB	; caractere 0xDB de la table ASCII | 0x07 --> texte en gris clair et arriere plan en noir
				rep 	stosq  
				
				mov		rax, Time
				push	Pronpt		; Equivaut  Call (1/2)
				jmp		rax			; 	    ...		  (2/2)
				
				Pronpt:
					mov		r8w, 111111b 	; Caractristique_du_curseur
					mov		r9w, 2  		; cursor_X
					mov		r10w, 2  		; cursor_Y	
				call	Pos_Curseur
				; --------------------------Met en place le prompt
				 mov 		edi, TRAM+2*80
				 mov		al, '>'
				 mov		ah, 0x38	
				stosw
	jmp		my_read
	;***************************************************************************************************************************
	;=============
	 ; Nbrlen
	 ; retourne la longueur d'un nombre 
	 ; Entre : r13	(nombre)
	 ; Sotie  : r12	(longueur du nombre)
	;=============
	nbrlen:
		mov		r11, 1
		xor		r12, r12
		mov		cl, 10
		Corps_nbrlen:
			inc		r12
			mov		rax, r11
			mul		cl
			mov		r11, rax
			cmp		r11, r11
		jb		Corps_nbrlen	
	ret
	;=============
	; /Nbrlen
	;=============
	
	;=============
	 ; Strlen
	 ; retourne la longueur d'une chane caractre (la chaine doit imprativement se terminer par 0 .
	 ; Entre : r15d	(pointeur sur la chaine)
	 ; Sotie  : r14w (longueur de la chaine)
	;=============
	strlen:
		xor		r14w, r14w
		dec		r15d
		Corps_strlen:
			inc		r14w
			inc		r15d
			cmp		[r15d], byte 0
		jne		Corps_strlen	
		dec		r14w
	ret
	;=============
	; /Strlen
	;=============
; 0000 0001	-->	1 (no-BCD)
; 0000 0001	-->	1 (BCD)

; 0000 1001	-->	9 (no-BCD)
; 0000 1001	-->	9 (BCD)

; 0000 1010	-->	10 (no-BCD)
; 0001 0000	--> 10 (BCD)

; 0000 1011	-->	11 (no-BCD)
; 0001 0001	--> 11 (BCD)

	;=============
	 ; nbr2BCD
	 ; retourne la longueur d'une chane de caractre et la chaine doit imprativement se terminer par 0
	 ; Entre : r15	(nombre non BCD)
	 ; Sotie  : r14	(nombre BCD)
	;=============
	 nbr2BCD:
   ;{
   ;}
   	;=============
	; /nbr2BCD
	;=============
	;***************************************************************************************************************************
	
	next_word:	
		;		+==============================+
		;		|BOUCLE		BOUCLE		BOUCLE |
		;		+==============================+
		;		Boucl jusqu' ce que 'r8d' pointe sur 0.
				
				boucle_next_word:
			   ;{	
					; Test de la boucle	
					inc		r8d
					cmp		[r8d], byte 0
				 jne		boucle_next_word
			   ;}
			   
		;		+=============================+
		;		| END_BOUCLE	END_BOUCLE 	  |		
		;		+=============================+
				inc		r8d
				cmp		r8d, end_cmd			
				je		cls					; on fface l'cran.	
				mov		edi, TRAM+2*80+2	; 2*80-->1 ligne + 2 ,  cause de la prscense du prompt '>' qui prend 2 octet	
				mov		bx, [r8d]  			; MAJ du nom de la fonction
				add		r8d, 2				; MAJ de l'adresse de la premirere lettre du mot  compar 	
	jmp		check 	; Efface l'cran 
	;***************************************************************************************************************************	
				
	check_cmd:		; 'AL' --> Lettre  compar
					; 'SI' --> Adresse de cmd	
					; 'EDI' --> Adresse des caractere  l'cran
					; 'BX' --> Numero de la fonction 
					mov		edi, TRAM+2*80+2	; 2*80-->1 ligne + 2 ,  cause de la prscense du prompt '>' qui prend 2 octet		
					mov		bx, [cmd]		; Affectation du nom de la fonction			
					mov		r8d, cmd+2		; Affectation de l'adresse de la premirere lettre du mot  compar 		 
					mov		ah, 0x38  		; Arriere plan du caractere NOIRE et couleur d'criture en BLANC
					
		;		+==============================+
		;		|BOUCLE		BOUCLE		BOUCLE |
		;		+==============================+
		; 		Vrifie que le buffer video contient une des chaines de carachteres definie dans 'cmd' en cmp caractere par caractere  partir de 0xB8002. 
				
 				 check:						
			   ;{	
					; Corps de la boucle
						mov		al, [r8d]
						scasw				; cmp	ax, [ES:DI]	  \n	add 	di, 2
						jne		next_word	; Si ax!= "du mot inscrit sur l'cran". On verifie r8d le mot n'est pas le prochain dans la liste de 'cmd'
						
					; Test de la boucle							
					inc		r8d 
					cmp		[r8d], byte 0	; r8d 'r8d' pointe sur 0 --> if(*r8d==0) { ::On va a la fonction attache au mot:: }.
				 jne		check			; (***)	 
			   ;}
			   
		;		+=============================+
		;		| END_BOUCLE	END_BOUCLE 	  |		
		;		+=============================+	
	;--------------Aller  la fonction 		   
	and		bx, bx
	je 		Reboot
	cmp 	bx, 1
	je		Exit
	cmp		bx, 2
	je		cls
	;***************************************************************************************************************************			
	
	Temporisation:

		mov al,0x02
		out 0x70,al
		in al,0x71
		mov bl,al


		boucle0:
			mov al,0x02
			out 0x70,al
			in al,0x70
			cmp al,bl
		je boucle0

	ret
	;***************************************************************************************************************************			
	Reboot:
	
		; Le saut qui suit est l'instruction qui se trouve  0xFFFF0 (merci  WinHex :) et s'appelle Reset vector ce qui a pour effet de "redmarrer" le CPU, 
		; c'est la 1st instruction excute par le CPU, bon comme vous voyez c'est encore un jump en (0xF000*16)+0xE05B= 0xFE05B.

		; l'emplacement du premier lment de ce mme tableau.
		mov 	word[0072h], 0000h 	 ;redemarrage a froid
									; 1234h   redemarrage a chaud
		jmp		0xFE05B
		
		; D'autres facon de rebooter:
				
			;*	; Redmarrer en utilisant le port d'E/S 0x64 du controlleur 8042 appartenant au clavier.
				; in 	al, 0x64
				; or 	al, 0xFE
				; out 	0x64, al
				; mov	al,0FEh
				; out	64h,al			; reboot computer
				; jmp	Reboot	
	
	;***************************************************************************************************************************		
	Exit:
		; CLS
		jmp		Reboot
			 ; mov 		edi, TRAM
			 ; mov		ecx, 0x1F4	
			 ; xor		rax, rax	; ascii 0
			; rep 	stosq	; Repeter 'cx' fois stosw --> mov	[ES:EDI], rax	 \n  add	edi, 8
		; Ne marche pas en 64 bits
			; mov 	edi, TRAM
		 ; jmp	0x7C00-0x1000		; Revenir  notre Bootloader situe en 0x7C00 dans la RAM.
	;***************************************************************************************************************************		
	%include "1.ASM/void_Date().asm"
	%include "1.ASM/gestionnaire_curseur.asm"
	
	;***************************************************************************************************************************	
	;=============
	 ; Keywait
	 ; Attend qu'une touche du clavier soit prsse via le controlleur 8042 et le stocke 
	 ; dans 'al'.
	 ; Entre : touche_clavier 
	 ; Sotie: al
	;=============	
	Keywait:
		; http://www.computer-engineering.org/ps2keyboard/
		; Le composant 8042 est accesible via les port 0x64 et 0x60, le port 0x64 sert  envoy des commandes vers le controlleur 8042.
		; Et le port 0x60 sert  envoyer les parmatres que la commande attend. Bien sur ces ports sont piloter en sortie (out).
		mov		al, 0xD2	; (Write keyboard buffer) - Parameter written to input buffer as if received from keyboard.
							;							traduc: Les parametres sont crit dans le buffer d'entre (accesible au port 0x60 en entre) 
							;							comme s'il le (buffer) recevait depuis les touches du clavier
		out		64h, al     	
		; BreakCodes= KeyUp	
		; MakeCodes= KeyDown
		; Scancode: |7|6|5|4|3|2|1|0|
		;			 | |_|_|_|_|_|_|_ -->{Scancode}
		;			 |
		;			 |--> '1'= BreakCodes '0'= MakeCodes
		mov		al, 0x80	; al=10000000b
		out		60h, al 
		keyup:
			call	Time
			in		al, 0x60
			and	 	al, 10000000b
		jnz		keyup	; Si le 8eme bit == 1 Alors sauter  keyup
		Keydown:
		in		al, 0x60
	ret
;====================================================================================================
;END_FONCTIONS		END_FONCTIONS		  END_FONCTIONS	    	END_FONCTIONS	    	END_FONCTIONS	
;====================================================================================================

;================================================================================================
;CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE	CODE
;================================================================================================
; Pour switcher en 64 bits j'ai pris comme modle le code  cette adresse: http://forum.osdev.org/viewtopic.php?p=90020 
; Aprs quelques changement de la GDT et de la syntaxe ( Le code tait destin pour FASM) il marche ^^ 
; Le IA32_EFER MSR est mis  0 aprs le dmarrage du .
; Avant d'entrer dans le mode 64 bits (IA-32e mode), on entre tout d'avord dans le mode protg puis on active la pagination (PG = Paging),
; l'extension d'adresse physique (PAE = Physical Address Extensions) avec 4 table de pages qui renforcent la structure de la pagination.
;
;
;	* and	{reg}, {value} ; on met des 0 sur les rangs binaire de 'value' que l'on veut mettre  0)
;	* or	{reg}, {value} ; on met des 1 sur les rangs binaire de 'value' que l'on veut mettre  1)
; 	Etape donnes par Intel pour rentrer dans le mode 64 bits:

; 	*1. On entre dans le mode protg, et on dsactive la pagination (CR0.PG = 0): 	mov		eax, cr0 		
;																					and		eax, 01111111111111111111111111111111b ; PG = 0
;																					mov		cr0, eax
; 		
; 	*2. Active l'extension d'adresse physique (PAE) CR4.PAE = 1: 	mov		eax, cr4
;																	or		eax, 100000b ; PAE = 1 . 1 = taille des pages = 4 Mo  
;																									 0 = taille des pages = 4 Ko (PAE = 1 est ignor).
;																	mov		cr4, eax 	 ; enable physical-address extensions
;
; 	*3. Copie l'adresse physique de base de PML4 dans CR3
;
; 	*4. Active le mode 64 bits : IA32_EFER.LME = 1.
;
; 	*5. Active la pagination paging by setting CR0.PG = 1. This causes the processor to set the 
;
[BITS 16]
main:
		
			; Rcupre l'adresse du LFB
			; mov		ax, 0x4F01
			; mov		di, info_mode  ;pointe sur une structure
			; mov		cx, 0x4115	 ;pour le mode 114h (4114h pour le LFB)
			; int		10h

			; Passage en mode vesa
			; mov		ax, 0x4F02
			; mov		bx, 0x4115 ; 800*600*16 m
			; int		10h
			
			
		; disable the interrupts
			cli				
			
		; Charge la GDT
			lgdt	[GDT64]		
	
	; *1:	
		; switch to protected mode		
			mov		eax, cr0 		
			or		al, 1b		; PE = 1
			mov		cr0, eax
			
		; Dsactiver la Pagination
			mov		eax, cr0 		
			and		eax, 01111111111111111111111111111111b ; PG = 0
			mov		cr0, eax
		jmp		(CODE_SELECTOR-GDT64):pm_start
	; *

[BITS 32]
pm_start:
		; Ecran tout blanc
			;  mov		edi, [PhysBasePtr]
			;  mov 		ecx, 800*600
			;  mov		ax, 0xFFFF  ;blanc
			; rep 		stosd
				
		; Fait pointer les regestres de segment vers le descripteur de code
			mov		ax, DATA_SELECTOR-GDT64	
			mov		ds, ax
			mov		es, ax
			mov		fs, ax
			mov		gs, ax
			mov		ss, ax 
			
	;*2:			
		; Active physical-address extensions (PAE)
			mov		eax, cr4
			or		eax, 100000b ; PAE = 1 . 1 = taille des pages = 4 Mo  
								 ; 			 0 = taille des pages = 4 Ko (PAE = 1 est ignor).
			mov		cr4, eax 	 ; enable physical-address extensions
	; *			
			
		; Ici on modidie les pages
		
			; "Nettoyage" des pages
				mov		edi, 0x70000
				mov		ecx, 0x10000
				xor		eax, eax
				rep		stosd			

			; Eciture de nouvelle donne dans les pages
				mov		dword [0x70000], 0x71000 + 7 ; first PDP table
				mov		dword [0x71000], 0x72000 + 7 ; first page directory
				mov		dword [0x72000], 0x73000 + 7 ; first page table

				mov		edi, 0x73000		; address of first page table
				mov		eax, 7
				mov		ecx, 256		; number of pages to map (1 MB)
				make_page_entries:
					stosd
					add		edi, 4
					add		eax, 0x1000
				loop	make_page_entries
				
	;*3:	
		; Copier l'adresse physique de base de PML4 dans CR3	
			mov		eax, 0x70000 	; Bass address of PML4
			mov		cr3, eax		; load page-map level-4 base
	; *			
	;*4:
		; Activer le mode 64 bits : IA32_EFER.LME = 1.

			; Pour modifier la structure on utilise les instructions: WRMSR et RDMSR.
			;
			; RDMSR = Read Model-Specific Registers. 
			;		  Charge le contenu du modle de registre 64-bits (MSR) indiquer par le registre ECX dans le couple de registre EDX:EAX.
			; WRMSR = Write Model-Specific Registers. 
			;		  Ecrit la valeur du couple EDX:EAX dans le MSR indiquer par le registre ECX .
			;	 _______________________________________________________________________________________________________________________________________________________________
			;	| 63 | 62 | 61 | 60 | 59 | 58 | 57 | 56 | 55 | 54 | 53 | 52 | 51 | 50 | 49 | 48 | 47 | 46 | 45 | 44 | 43 | 42 | 41 | 40 | 39 | 38 | 37 | 36 | 35 | 34 | 33 | 32 |
			;	|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|
			;	|																																								|
			;	|																																								|
			;	|								Reserved														     ___________________________________________________________|
			;	|																								    |	 |	  |    |	|								   |	|
			;	|				  			  																	    |NXE |LMA |Res.|LME	|			Reserved (Res.)	  	   |SCE |
			;	|___________________________________________________________________________________________________|____|____|____|____|_________________________________ |____|
			;	| 31 | 30 | 29 | 28 | 27 | 26 | 25 | 24 | 23 | 22 | 21 | 20 | 19 | 18 | 17 | 16 | 15 | 14 | 13 | 12 | 11 | 10 | 9  | 8  | 7  | 6  |  5 |  4 | 3  |  2 |  1 |  0 |
			;   |____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____|____| 
			;																										  |	   |         |                                       |_ SysCall enable  
			;																										  |	   |         |_ IA-32e mode enable = 64 bits
			;																										  |	   |_ IA-32e mode active = 64 bits
			;																										  |_ Execute disable bit enable	
			mov		ecx, 0xC0000080		; adresse du MSR
			rdmsr						; Lit le MSR
			or		eax, 100000000b		; LME = 1. (Long Mode Enable)
			wrmsr						; Ecrit dans le MSR
			
	;*5:		
		; Activer la Pagination
			mov		eax, cr0
			or		eax, 10000000000000000000000000000000b ; Met le 31-me bit (PG = Paging)  1
			mov		cr0, eax 		
		jmp		(LONG_SELECTOR-GDT64):KERNEL64
	; *
[BITS 64]
KERNEL64:

		jmp		cls
		

				
		; Remplie le 1 Chunk of screen red
			; mov		ecx, 0x10000
			; mov		rax, 0x00FF000000FF0000
			; mov		edi, VRAM
			; col:
				; stosq
			; loop	col
		
			; mov     rax, 'L O N G '
			; mov     [0x0B8000], rax
			; cli
			; hlt
			 
			 ; mov 		edi, TRAM
			 ; mov 	[param_my_write], dword msg
			 ; mov 	[param_my_write + 4], dword end_msg		; Adresse de fin de msg 
		; call	my_write
		
;================================================================================================
;END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	END_CODE	
;================================================================================================	

times 256 db 0	; '$' correspond a l'adresse du dbut du code .
