[BITS 64]
;	void Time ( char Heure[8] );

			; I/ INTRO
			;
			; 		Le but de cette fonction est d'afficher l'heure, pour cela on utilise la fonction 2 de l'interruption 0x1A.
			;																																											   					
			; 	Cette fonction une fois appele, nous renvoie l'heure sous forme BCD (binary coded decimal), c-a-d si par exemple il est 14:32:12, alors ch=0x14, cl=0x32 et dh=0x12. 
			;
			;																								       /<-- Base de 10	
			;	14(10) = 1110(2) cette galit vaut pour le codage binaire pur, mais pas pour le BCD, qui est 14(10)= 0001  0100 (2) =	10100(2)
			;																										  1(10)	4(10)
			; 	C'est bon vous avez compris :) alors passons au fonctionnement
			
			; II/ FONCTIONNEMENT
			;
			; 		Pour afficher l'heure cette fonction est divis en 2 partie . L'une est de sparer chaque mot (1 mot = 1 octet = 8 bits) des registres (ch(H) , cl(M) , dh(S))
			;   en demi-mot, donc 4 bits, pour ensuite les mettres dans un array nomme Heure contenant de 8 char (8 byte). (seul 6 char seront utilise lors du transfert)
			; 	
			;   Simple non ? :)
			;   Enfin la deuxieme partie est, vous l'aurez devinez, est d'afficher notre heure ;)
			
	Time:	
	
		; On cris le numro du registre dans le port 0x70 puis on lit la valeur correspondante dans le port 0x71
		
		; liste des registres du port 0x70 :
			; Port du RTC (Real Time Clock)

		; Toutes les valeurs sont donne sous forme BCD rcuprr dans 'al' in first
		; 00h = secondes
		; 01h = secondes de l'alarme
		; 02h = minutes
		; 03h = minutes de l'alarme
		; 04h = heures
		; 05h = heures de l'alarme
		; 06h = jour de la semaine
		; 07h = jour du mois
		; 08h = mois
		; 09h = anne
		

;                     ax = 0000 0000 0001 0001 = 0x011
;                    /         
;    shl    ax, 4 -->:                           
;                    \                    <---     
;                     ax = 0000 0001 0001 0000 = 0x110
;   Les bits sont dcalls de 4 rang vers la gauche, ce qui multiplie la valeur de ax par 2^4=16.

;                      ax = 0000 0000 0001 0001 = 0x11
;                     /         
;    shr    ax, 4 -->:                           
;                     \     --->                
;                      ax = 0000 0000 0000 0001 = 0x01
;    Les bits sont dcalls de 4 rang vers la droite, ce qui divise la valeur de ax par 2^4=16.

		; Port du RTC (Real Time Clock)
			mov		esi, Date
			
		; Seconde (0)
			xor		ax, ax
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4			; ax*0x10
			shr		al, 4			; al/=0x10;
			add		ax, 0x3030		; 48(10) --> '0' cf: table ASCII
			mov		[esi + 17], ah
			mov		[esi + 18], al
			
			
		; Minutes (2)	
			mov		ax, 2
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4
			shr		al, 4
			add		ax, 0x3030
			mov		[esi + 14], ah
			mov		[esi + 15], al
			
			
		; Heure (4)
			mov		ax, 4
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4
			shr		al, 4
			add		ax, 0x3030		
			mov		[esi + 11], ah
			mov		[esi + 12], al
			

		; Jour du mois (7)	
			mov		ax, 7
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4
			shr		al, 4
			add		ax, 0x3030	
			mov		[esi], ah
			mov		[esi+1], al
			

		; Mois (8)	
			mov		ax, 8
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4
			shr		al, 4
			add		ax, 0x3030	
			mov		[esi + 3], ah
			mov		[esi + 4], al
			
			
		; Anne	(9)
			mov		ax, 9
			out		0x70, al 
			in		al, 0x71
			shl		ax, 4
			shr		al, 4
			add		ax, 0x3030	
			mov		[esi + 8], ah
			mov		[esi + 9], al
			
			; Paramatres passer  my_write
				push	rdi
				mov 	edi, TRAM
				mov		ah, 1110100b
				mov 	[param_my_write], dword Date
				mov 	[param_my_write + 4], dword end_Date
			call	my_write	
				pop		rdi
	ret 